diff --git a/drupal7/sites/all/modules/media/includes/media.pages.inc b/drupal7/sites/all/modules/media/includes/media.pages.inc
index 28a6d7ee..b22a8b14 100644
--- a/drupal7/sites/all/modules/media/includes/media.pages.inc
+++ b/drupal7/sites/all/modules/media/includes/media.pages.inc
@@ -5,67 +5,6 @@
  * Common pages for the Media module.
  */
 
-
-/**
- * Menu callback; Edit multiple files on the same page using multiform module.
- *
- * @todo When http://drupal.org/node/1227706 is fixed, filter the $files
- * array using file_access($file, 'edit').
- *
- * @see media_file_operation_edit_multiple()
- */
-function media_file_page_edit_multiple($files) {
-  if (empty($files)) {
-    return MENU_ACCESS_DENIED;
-  }
-
-  $forms = array();
-  foreach ($files as $file) {
-    // To maintain unique form_ids, append the file id.
-    $forms[] = array('media_edit_' . $file->fid, $file);
-  }
-
-  $form = call_user_func_array('multiform_get_form', $forms);
-  $form['#attributes']['class'][] = 'media-multiedit-form';
-
-  // Add the title to each 'subform'.
-  foreach (element_children($form['multiform']) as $key) {
-    $fid = $form['multiform'][$key]['fid']['#value'];
-    $file = $files[$fid];
-    $title = t('<em>Edit @type</em> @title', array('@type' => $file->type, '@title' => $file->filename));
-    $form['multiform'][$key]['#prefix'] = '<h2>' . $title . '</h2>';
-    $form['multiform'][$key]['actions']['#access'] = FALSE;
-  }
-
-  if (isset($form['buttons']['Delete'])) {
-    $form['buttons']['Delete']['#access'] = FALSE;
-  }
-
-  // Add a cancel button at the bottom of the form.
-  $form['buttons']['cancel'] = array(
-    '#type' => 'link',
-    '#title' => t('Cancel'),
-    '#weight' => 50,
-  );
-  if (isset($_GET['destination'])) {
-    $form['buttons']['cancel']['#href'] = $_GET['destination'];
-  }
-  else if (user_access('administer files')) {
-    $form['buttons']['cancel']['#href'] = 'admin/content/file';
-  }
-  else {
-    $form['buttons']['cancel']['#href'] = '<front>';
-  }
-
-  // Override the page title since each file form sets a title.
-  drupal_set_title(t('Edit multiple files'));
-
-  // Allow other modules to alter the form.
-  drupal_alter('media_edit_multiple_form', $form);
-
-  return $form;
-}
-
 /**
  * CTools modal callback for editing a file.
  */
@@ -92,196 +31,3 @@ function media_file_edit_modal($form, &$form_state, $file, $js) {
   // Otherwise, just return the output.
   return $output;
 }
-
-/**
- * File type migration page.
- *
- * Allows site administrator to execute migration of old/disabled/deleted
- * file types to new ones.
- */
-function media_upgrade_file_types($form, &$form_state) {
-  $migratable_types = _media_get_migratable_file_types();
-
-  // Silently return if there are no file types that need migration.
-  if (empty($migratable_types)) {
-    return array(
-      'message' => array(
-        '#markup' => t('There are no file types that need migration.'),
-      ),
-    );
-  }
-
-  $form['message'] = array(
-    'message' => array(
-      '#markup' => t('This page allows you to migrate deprecated and/or disabled file types to new ones. It will migrate files from old type to new one and optionally migrate fields and delete old type.'),
-    ),
-  );
-
-  $form['migrate_fields'] = array(
-    '#type' => 'checkbox',
-    '#title' => t('Migrate fields'),
-    '#default_value' => TRUE,
-    '#description' => t('Migrate fields and their values from old file types to new ones.'),
-  );
-  $form['delete_old_type'] = array(
-    '#type' => 'checkbox',
-    '#title' => t('Delete old type'),
-    '#default_value' => FALSE,
-    '#description' => t('Delete old file type if migration was successful and delete operation is possible (type is not exported in code).'),
-  );
-  $form['migrate_mimes'] = array(
-    '#type' => 'checkbox',
-    '#title' => t('Migrate type mime-type'),
-    '#default_value' => TRUE,
-    '#description' => t('Move mime-type from old type to new one.'),
-  );
-
-  $form['upgradable_types'] = array(
-    '#type' => 'fieldset',
-    '#title' => t('Upgradable file types'),
-  );
-
-  $options = array('- ' . t('Do not upgrade') . ' -');
-  foreach (file_type_get_enabled_types() as $type) {
-    $options[$type->type] = $type->label;
-  }
-
-  foreach ($migratable_types as $machine_name) {
-    $type = file_type_load($machine_name);
-    if (!$type) {
-      $type = new stdClass;
-      $type->label = $type->type = $machine_name;
-    }
-    $form['upgradable_types'][$machine_name] = array(
-      '#type' => 'select',
-      '#title' => $type->label,
-      '#options' => $options,
-      '#description' => t(
-        'Select file type which you want to migrate @type to. Select %no_upgrade if type should stay as it is.',
-        array('@type' => $type->label, '%no_upgrade' => '- ' . t('Do not upgrade') . ' -')),
-    );
-  }
-
-  $form['submit'] = array(
-    '#type' => 'submit',
-    '#value' => t('Start migraton'),
-  );
-
-  return $form;
-}
-
-/**
- * File type migration page submit handler.
- */
-function media_upgrade_file_types_submit($form, &$form_state) {
-  $migratable_types = _media_get_migratable_file_types();
-  $migrate = FALSE;
-  foreach ($migratable_types as $type) {
-    if ($form_state['values'][$type]) {
-      $migrate = TRUE;
-      break;
-    }
-  }
-
-  // Return silently if no types were selected for migration.
-  if (!$migrate) {
-    return;
-  }
-
-  // Use confirmation page/form.
-  $query = $form_state['values'];
-  unset($query['op']);
-  unset($query['submit']);
-  unset($query['form_id']);
-  unset($query['form_token']);
-  unset($query['form_build_id']);
-
-  $form_state['redirect'] = array(
-    'admin/structure/file-types/upgrade/confirm',
-    array('query' => $query),
-  );
-}
-
-/**
- * File types migration confirmation page.
- */
-function media_upgrade_file_types_confirm($form, &$form_state) {
-  return confirm_form(
-    $form,
-    t('Do you really want to migrate selected file types?'),
-    'admin/structure/file-types/upgrade',
-    NULL,
-    t('Migrate')
-  );
-}
-
-/**
- * File types migration confirmation page sumit. Executes actual migration.
- */
-function media_upgrade_file_types_confirm_submit($form, &$form_state) {
-  $migratable_types = _media_get_migratable_file_types();
-  foreach ($migratable_types as $type) {
-    if ($_GET[$type] && $bundle_new = file_type_load($_GET[$type])) {
-      // Old bundle might be deleted so let's fake some values.
-      $bundle_old = file_type_load($type);
-      if (empty($bundle_old)) {
-        $bundle_old = new stdClass;
-        $bundle_old->type = $type;
-        $bundle_old->mimetypes = array();
-        $bundle_old->export_type = 2;
-      }
-
-      // Migrate fields to new bundle.
-      if ($_GET['migrate_fields']) {
-        $old_fields = db_select('field_config_instance', 'fc')->fields('fc', array('field_name'))->condition('entity_type',  'file')->condition('bundle', $bundle_old->type)->execute()->fetchCol();
-        $new_fields = db_select('field_config_instance', 'fc')->fields('fc', array('field_name'))->condition('entity_type',  'file')->condition('bundle', $bundle_new->type)->execute()->fetchCol();
-        $fields_to_move = array_diff($old_fields, $new_fields);
-        $fields_to_drop = array_diff($old_fields, $fields_to_move);
-
-        db_update('field_config_instance')
-          ->fields(array('bundle' => $bundle_new->type))
-          ->condition('entity_type',  'file')
-          ->condition('bundle', $bundle_old->type)
-          ->condition('field_name', $fields_to_move, 'IN')
-          ->execute();
-
-        db_delete('field_config_instance')
-          ->condition('entity_type',  'file')
-          ->condition('bundle', $bundle_old->type)
-          ->condition('field_name', $fields_to_drop, 'IN')
-          ->execute();
-
-        field_cache_clear();
-        module_invoke_all('field_attach_rename_bundle', 'file', $bundle_old->type, $bundle_new->type);
-      }
-
-      // Migrate mimetypes to new bundle.
-      if ($_GET['migrate_mimes']) {
-        $changed = FALSE;
-        foreach ($bundle_old->mimetypes as $mime) {
-          if (!file_entity_match_mimetypes($bundle_new->mimetypes, $mime)) {
-            $bundle_new->mimetypes[] = $mime;
-            $changed = TRUE;
-          }
-        }
-
-        if ($changed) {
-          file_type_save($bundle_new);
-        }
-      }
-
-      // Delete old bundle.
-      if ($_GET['delete_old_type'] && $bundle_old->export_type == 1) {
-        file_type_delete($bundle_old);
-      }
-
-      // Migrate files.
-      db_update('file_managed')
-        ->fields(array('type' => $bundle_new->type))
-        ->condition('type', $bundle_old->type)
-        ->execute();
-    }
-  }
-
-  $form_state['redirect'] = 'admin/structure/file-types';
-}
diff --git a/drupal7/sites/all/modules/media/includes/media.theme.inc b/drupal7/sites/all/modules/media/includes/media.theme.inc
index 204cedc7..2b57782e 100644
--- a/drupal7/sites/all/modules/media/includes/media.theme.inc
+++ b/drupal7/sites/all/modules/media/includes/media.theme.inc
@@ -7,28 +7,6 @@
  * Theming functions for the Media module.
  */
 
-
-/**
- * Display a media file list.
- *
- * @param array $element
- *   The form element.
- *
- * @return string
- *   HTML of the file list
- */
-function theme_media_file_list($element) {
-  // Add the CSS for our display.
-  return '<div class="media-file-list">' . theme('form_element', $element, $element['#children']) . '</div>';
-}
-
-/**
- * Add messages to the page.
- */
-function template_preprocess_media_dialog_page(&$variables) {
-  $variables['messages'] = theme('status_messages');
-}
-
 /**
  * Adds a wrapper around a preview of a media file.
  */
@@ -47,11 +25,18 @@ function theme_media_thumbnail($variables) {
 
   // Arguments for the thumbnail link.
   $thumb = $element['#children'];
-  $target = 'file/' . $element['#file']->fid . '/edit';
+  if (file_entity_access('update', $element['#file'])) {
+    $target = 'file/' . $element['#file']->fid . '/edit';
+    $title = t('Click to edit details');
+  }
+  else {
+    $target = 'file/' . $element['#file']->fid;
+    $title = t('Click to view details');
+  }
   $options = array(
     'query' => drupal_get_destination(),
     'html' => TRUE,
-    'attributes' => array('title' => t('Click to edit details')),
+    'attributes' => array('title' => $title),
   );
 
   // Element should be a field renderable array. This should be improved.
@@ -85,7 +70,7 @@ function template_preprocess_media_thumbnail(&$variables) {
  */
 function theme_media_formatter_large_icon($variables) {
   $file = $variables['file'];
-  $icon_dir = variable_get('media__icon_base_directory', 'public://media-icons') . '/' . variable_get('media__icon_set', 'default');
+  $icon_dir = variable_get('media_icon_base_directory', 'public://media-icons') . '/' . variable_get('media_icon_set', 'default');
   $icon = file_icon_path($file, $icon_dir);
   $variables['path'] = $icon;
 
@@ -108,3 +93,10 @@ function theme_media_formatter_large_icon($variables) {
   }
   return $output;
 }
+
+/**
+ * Add messages to the page.
+ */
+function template_preprocess_media_dialog_page(&$variables) {
+  $variables['messages'] = theme('status_messages');
+}
diff --git a/drupal7/sites/all/modules/media/js/media.browser.js b/drupal7/sites/all/modules/media/js/media.browser.js
index c81e7331..d16e52aa 100644
--- a/drupal7/sites/all/modules/media/js/media.browser.js
+++ b/drupal7/sites/all/modules/media/js/media.browser.js
@@ -7,7 +7,6 @@
 namespace('Drupal.media.browser');
 
 Drupal.media.browser.selectedMedia = [];
-Drupal.media.browser.activeTab = 0;
 Drupal.media.browser.mediaAdded = function () {};
 Drupal.media.browser.selectionFinalized = function (selectedMedia) {
   // This is intended to be overridden if a callee wants to be triggered
@@ -24,23 +23,42 @@ Drupal.behaviors.MediaBrowser = {
     }
 
     // Instantiate the tabs.
+    var showFunc = function(event, ui) {
+      // Store index of the tab being activated.
+      if (parent_iframe = Drupal.media.browser.getParentIframe(window)) {
+        $(parent_iframe).attr('current_tab', $('#media-tabs-wrapper > ul > li.ui-state-active').index());
+      }
+    };
+    var activeTab = Drupal.media.browser.tabFromHash();
     $('#media-browser-tabset').tabs({
-      // Ensure that the modal resizes to the content on each tab switch.
-      show: Drupal.media.browser.resizeIframe, // jquery ui < 1.8
-      activate: Drupal.media.browser.resizeIframe // jquery ui >= 1.8
-    });
-
-    $('.ui-tabs-nav li').mouseup(function() {
-      Drupal.media.browser.activeTab = $(this).index();
+      selected: activeTab, // jquery < 1.9
+      active: activeTab, // jquery >= 1.9
+      show: showFunc, // jquery ui < 1.8
+      activate: showFunc // jquery ui >= 1.8
     });
 
     $('.media-browser-tab').each( Drupal.media.browser.validateButtons );
+  }
+  // Wait for additional params to be passed in.
+};
 
-    Drupal.media.browser.selectActiveTab();
-    Drupal.media.browser.selectErrorTab();
+Drupal.media.browser.getParentIframe = function (window) {
+  var arrFrames = parent.document.getElementsByTagName("IFRAME");
+  for (var i = 0; i < arrFrames.length; i++) {
+    if (arrFrames[i].contentWindow === window) {
+      return arrFrames[i];
+    }
+  }
+}
 
+/**
+ * Get index of the active tab from window.location.hash
+ */
+Drupal.media.browser.tabFromHash = function () {
+  if (parent_iframe = Drupal.media.browser.getParentIframe(window)) {
+    return $(parent_iframe).attr('current_tab');
   }
-  // Wait for additional params to be passed in.
+  return 0;
 };
 
 Drupal.media.browser.launch = function () {
@@ -49,17 +67,16 @@ Drupal.media.browser.launch = function () {
 
 Drupal.media.browser.validateButtons = function() {
   // The media browser runs in an IFRAME. The Drupal.media.popups.mediaBrowser()
-  // function sets up the IFRAME and "OK" and "Cancel" buttons that are outside
-  // of the IFRAME, so that their click handlers can destroy the IFRAME while
-  // retaining information about what media items were selected. However,
-  // Drupal UI convention is to place all action buttons on the same "line"
-  // at the bottom of the form, so if the form within the IFRAME contains a
-  // "Submit" button or other action buttons, then the "OK" and "Cancel"
-  // buttons below the IFRAME break this convention and confuse the user.
-  // Therefore, we add "Submit" and "Cancel" buttons inside the IFRAME, and
-  // have their click action trigger the click action of the corresonding
-  // "OK" and "Cancel" buttons that are outside the IFRAME. media.css contains
-  // CSS rules that hide the outside buttons.
+  // function sets up the IFRAME and an "OK" button that is outside of the
+  // IFRAME, so that its click handlers can destroy the IFRAME while retaining
+  // information about what media items were selected. However, Drupal UI
+  // convention is to place all action buttons on the same "line" at the bottom
+  // of the form, so if the form within the IFRAME contains a "Submit" button or
+  // other action buttons, then the "OK" button will appear below the IFRAME
+  // which breaks this convention and is confusing to the user. Therefore, we
+  // add a "Submit" button inside the IFRAME, and have its click action trigger
+  // the click action of the corresponding "OK" button that is outside the
+  // IFRAME. media.css contains CSS rules that hide the outside buttons.
 
   // If a submit button is present, another round-trip to the server is needed
   // before the user's selection is finalized. For these cases, when the form's
@@ -69,24 +86,18 @@ Drupal.media.browser.validateButtons = function() {
   // Drupal.media.popups.mediaBrowser.mediaBrowserOnLoad() auto-triggers the
   // "OK" button action to finalize the selection and remove the IFRAME.
 
-  // We need to check for the fake submit/cancel buttons that are used on
-  // non-form based pane content. On these items we need to bind the clicks
-  // so that media can be selected or the window can be closed. This is still a
-  // hacky approach, but it is a step in the right direction.
+  // We need to check for the fake submit button that is used on non-form based
+  // pane content. On these items we need to bind the clicks so that media can
+  // be selected or the window can be closed. This is still a hacky approach,
+  // but it is a step in the right direction.
 
   $('a.button.fake-submit', this).once().bind('click', Drupal.media.browser.submit);
-  $('a.button.fake-cancel', this).once().bind('click', Drupal.media.browser.submit);
 };
 
 Drupal.media.browser.submit = function () {
   // @see Drupal.media.browser.validateButtons().
   var buttons = $(parent.window.document.body).find('#mediaBrowser').parent('.ui-dialog').find('.ui-dialog-buttonpane button');
-  if ($(this).hasClass('fake-cancel')) {
-    buttons[1].click();
-  }
-  else {
-    buttons[0].click();
-  }
+  buttons[0].click();
 
   // Return false to prevent the fake link "click" from continuing.
   return false;
@@ -105,56 +116,4 @@ Drupal.media.browser.finalizeSelection = function () {
   }
 };
 
-/**
- * Resize the Media Browser to the content height.
- */
-Drupal.media.browser.resizeIframe = function (event) {
-  var h = $('body').height();
-  $(parent.window.document).find('#mediaBrowser').height(h);
-};
-
-Drupal.media.browser.selectErrorTab = function() {
-  // Find the ID of a tab with an error in it
-  var errorTabID = $('#media-browser-tabset')
-    .find('.error')
-    .parents('.media-browser-tab')
-    .attr('id');
-
-  if (errorTabID !== undefined) {
-    // Find the Tab Link with errorTabID
-    var tab = $('a[href="#' + errorTabID + '"]');
-    // Find the index of the tab
-    var index = $('#media-browser-tabset a').index(tab);
-    // Select the tab
-    Drupal.media.browser.selectTab(index);
-  }
-}
-
-Drupal.media.browser.selectActiveTab = function() {
-  // Find the index of the last active tab.
-  setTimeout(function() {
-    Drupal.media.browser.selectTab(Drupal.media.browser.activeTab);
-    Drupal.media.browser.resizeIframe();
-  }, 10);
-};
-
-/**
- * Helper function to change the media browser jQuery UI tabs
- * since it requires two different methods dependingon the version.
- */
-Drupal.media.browser.selectTab = function(index) {
-  var ver = jQuery.ui.version.split('.');
-  if (ver[0] == '1' && parseInt(ver[1]) <= 8) {
-    // jQuery UI <= 1.8
-    $('#media-browser-tabset').tabs('select', index);
-  }
-  else {
-    // jQuery UI 1.9+
-    $('#media-browser-tabset').tabs('option', 'active', index);
-  }
-
-  // Update the active tab variable.
-  Drupal.media.browser.activeTab = index;
-};
-
 }(jQuery));
diff --git a/drupal7/sites/all/modules/media/js/media.js b/drupal7/sites/all/modules/media/js/media.js
index 04585bde..5288dd30 100644
--- a/drupal7/sites/all/modules/media/js/media.js
+++ b/drupal7/sites/all/modules/media/js/media.js
@@ -1,97 +1,125 @@
-
 /**
- *  @file
- *  This file handles the JS for Media Module functions.
+ * @file
+ * Provides JavaScript additions to the media field widget.
+ *
+ * This file provides support for launching the media browser to select existing
+ * files and disabling of other media fields during Ajax uploads (which prevents
+ * separate media fields from accidentally attaching files).
  */
 
 (function ($) {
 
 /**
- * Loads media browsers and callbacks, specifically for media as a field.
+ * Attach behaviors to media element browse fields.
  */
 Drupal.behaviors.mediaElement = {
   attach: function (context, settings) {
-    // Options set from media.fields.inc for the types, etc to show in the browser.
-
-    // For each widget (in case of multi-entry)
-    $('.media-widget', context).once('mediaBrowserLaunch', function () {
-      var options = settings.media.elements[this.id];
-      globalOptions = {};
-      if (options.global != undefined) {
-        var globalOptions = options.global;
-      }
-      //options = Drupal.settings.media.fields[this.id];
-      var fidField = $('.fid', this);
-      var previewField = $('.preview', this);
-      var editButton = $('.edit', this);
-      var removeButton = $('.remove', this);
-
-      // Hide the edit and remove buttons if there is no file data yet.
-      if (fidField.val() == 0) {
-        if (editButton.length) {
-          editButton.hide();
-        }
-        removeButton.hide();
-      }
-
-      // When someone clicks the link to pick media (or clicks on an existing thumbnail)
-      $('.launcher', this).bind('click', function (e) {
-        // Launch the browser, providing the following callback function
-        // @TODO: This should not be an anomyous function.
-        Drupal.media.popups.mediaBrowser(function (mediaFiles) {
-          if (mediaFiles.length < 0) {
-            return;
-          }
-          var mediaFile = mediaFiles[0];
-          // Set the value of the filefield fid (hidden) and trigger a change.
-          fidField.val(mediaFile.fid);
-          fidField.trigger('change');
-          // Set the preview field HTML.
-          previewField.html(mediaFile.preview);
-        }, globalOptions);
-        e.preventDefault();
+    if (settings.media && settings.media.elements) {
+      $.each(settings.media.elements, function(selector) {
+        $(selector, context).once('media-browser-launch', function () {
+          var configuration = settings.media.elements[selector];
+          // The user has JavaScript enabled, so display the browse field and hide
+          // the upload and attach fields which are only used as a fallback in
+          // case the user is unable to use the media browser.
+          $(selector, context).children('.browse').show();
+          $(selector, context).children('.upload').hide();
+          $(selector, context).children('.attach').hide();
+          $(selector, context).children('.browse').bind('click', {configuration: configuration}, Drupal.media.openBrowser);
+        });
       });
+    }
+  }
+};
 
-      // When someone clicks the Remove button.
-      $('.remove', this).bind('click', function (e) {
-        // Set the value of the filefield fid (hidden) and trigger change.
-        fidField.val(0);
-        fidField.trigger('change');
-        // Set the preview field HTML.
-        previewField.html('');
-        e.preventDefault();
-      });
+/**
+ * Attach behaviors to the media attach and remove buttons.
+ */
+Drupal.behaviors.mediaButtons = {
+  attach: function (context) {
+    $('input.form-submit', context).bind('mousedown', Drupal.media.disableFields);
+  },
+  detach: function (context) {
+    $('input.form-submit', context).unbind('mousedown', Drupal.media.disableFields);
+  }
+};
 
-      // Show or hide the edit/remove buttons if the field has a file or not.
-      $('.fid', this).bind('change', function() {
-        if (fidField.val() == 0) {
-          if (editButton.length) {
-            editButton.hide();
-          }
-          removeButton.hide();
-        }
-        else {
-          if (editButton.length) {
-            var url = Drupal.settings.basePath + 'file/' + fidField.val() + '/edit';
-            $.ajax({
-              url: location.protocol + '//' + location.host + url,
-              type: 'HEAD',
-              success: function(data) {
-                editButton.attr('href', editButton.attr('href').replace(/media\/\d+\/edit/, 'media/' + fidField.val() + '/edit'));
-                // Re-process the edit link through CTools modal behaviors.
-                editButton.unbind('click');
-                editButton.removeClass('ctools-use-modal-processed');
-                // @todo Maybe add support for Drupal.detachBehaviors in Drupal.behaviors.ZZCToolsModal?
-                Drupal.attachBehaviors(editButton.parent(), Drupal.settings);
-                editButton.show();
-              }
-            });
-          }
-          removeButton.show();
-        }
-      });
-    });
+/**
+ * Media attach utility functions.
+ */
+Drupal.media = Drupal.media || {};
+
+/**
+ * Opens the media browser with the element's configuration settings.
+ */
+Drupal.media.openBrowser = function (event) {
+  var clickedButton = this;
+  var configuration = event.data.configuration.global;
+
+  // Find the file ID, preview and upload fields.
+  var fidField = $(this).siblings('.fid');
+  var previewField = $(this).siblings('.preview');
+  var uploadField = $(this).siblings('.upload');
+
+  // Find the edit and remove buttons.
+  var editButton = $(this).siblings('.edit');
+  var removeButton = $(this).siblings('.remove');
+
+  // Launch the media browser.
+  Drupal.media.popups.mediaBrowser(function (mediaFiles) {
+    // Ensure that there was at least one media file selected.
+    if (mediaFiles.length < 0) {
+      return;
+    }
+
+    // Grab the first of the selected media files.
+    var mediaFile = mediaFiles[0];
+
+    // Set the value of the hidden file ID field and trigger a change.
+    uploadField.val(mediaFile.fid);
+    uploadField.trigger('change');
+
+    // Find the attach button and automatically trigger it.
+    var attachButton = uploadField.siblings('.attach');
+    attachButton.trigger('mousedown');
+
+    // Display a preview of the file using the selected media file's display.
+    previewField.html(mediaFile.preview);
+  }, configuration);
+
+  return false;
+};
+
+/**
+ * Prevent media browsing when using buttons not intended to browse.
+ */
+Drupal.media.disableFields = function (event) {
+  var clickedButton = this;
+
+  // Only disable browse fields for Ajax buttons.
+  if (!$(clickedButton).hasClass('ajax-processed')) {
+    return;
   }
+
+  // Check if we're working with an "Attach" button.
+  var $enabledFields = [];
+  if ($(this).closest('div.media-widget').length > 0) {
+    $enabledFields = $(this).closest('div.media-widget').find('input.attach');
+  }
+
+  // Temporarily disable attach fields other than the one we're currently
+  // working with. Filter out fields that are already disabled so that they
+  // do not get enabled when we re-enable these fields at the end of behavior
+  // processing. Re-enable in a setTimeout set to a relatively short amount
+  // of time (1 second). All the other mousedown handlers (like Drupal's Ajax
+  // behaviors) are excuted before any timeout functions are called, so we
+  // don't have to worry about the fields being re-enabled too soon.
+  // @todo If the previous sentence is true, why not set the timeout to 0?
+  var $fieldsToTemporarilyDisable = $('div.media-widget input.attach').not($enabledFields).not(':disabled');
+  $fieldsToTemporarilyDisable.attr('disabled', 'disabled');
+  setTimeout(function (){
+    $fieldsToTemporarilyDisable.attr('disabled', false);
+  }, 1000);
 };
 
 })(jQuery);
+
